#include <unistd.h>
#include <stdlib.h>
#include <assert.h>
#include <SDL/SDL.h>
#include "colour.h"
#include "cinfo.h"

extern SDL_Surface*screen;

void
colour_init()
{
  int i,j;

  for(i=0;i<MAX_CID;i++)
  {
    for(j=0;j<cin_list[i].n&&j<MAX_CMAP;j++)
    {
#ifdef DEBUG_COLOURS
      printf("  read %d %d %d\n",
        cin_list[i].cm[j].r,
        cin_list[i].cm[j].g,
        cin_list[i].cm[j].b);
      printf("  c=%d\n",cin_list[i].cm[j].c);
#endif

      cin_list[i].cm[j].c
        =SDL_MapRGB( screen->format,
          cin_list[i].cm[j].r,
          cin_list[i].cm[j].g,
          cin_list[i].cm[j].b);
    }
    assert(j<MAX_CMAP);
  }
  assert(i==MAX_CID);
}

Uint32
colour_lookup(int cid,int idx)
{
  assert(cid>=0);
  assert(cid<=MAX_CID);
  assert(0<=idx);
  if(idx>=cin_list[cid].n)
    assert(0);
#ifdef DEBUG_COLOURS
  printf("colour %d\n",cin_list[cid].cm[idx].c);
#endif
  return cin_list[cid].cm[idx].c;
}

void
colour_finalize()
{
}


