#include "scene.h"
#include "dlink.h"

struct dlink*
dlink_alloc_init()
{
  struct dlink *dl;
  dl=(struct dlink*)xmalloc(sizeof(struct dlink));
  dl->d=NULL;
  dl->next=NULL;
  return dl;
}

void
dlink_empty(struct dlink*dl)
{
  assert(dl);
  while(dl->next)
  {
    struct dlink*_dl=dl->next->next;
    xfree(dl->next);
    dl->next=_dl;
  }
}

int
dlink_is_empty(struct dlink*dl)
{
  assert(dl);
  return(dl->next==NULL);
}

void
dlink_push(struct dlink*dl,struct draw_item*d)
{
  struct dlink*_dl;
  assert(dl);
  assert(d);
  _dl=dlink_alloc_init();
  _dl->d=d;
  _dl->next=dl->next;
  dl->next=_dl;
}

struct draw_item*
dlink_pop(struct dlink*dl)
{
  struct dlink*_dl;
  struct draw_item*d;
  assert(dl);
  _dl=dl->next;
  dl->next=dl->next->next;
  d=_dl->d;
  xfree(_dl);
  return d;
}

struct draw_item*
dlink_top(struct dlink*dl)
{
  assert(dl);
  return dl->next->d;
}

int
dlink_remove(struct dlink*dl,struct draw_item*d)
{
  struct dlink*_dl;
  assert(dl);
  assert(d);
  for(_dl=dl;_dl->next;_dl=_dl->next)
    if(_dl->next->d==d)
    {
      dlink_pop(_dl);
      return 1;
    }
  return 0;
}

void
dlink_free(struct dlink*dl)
{
  assert(dl);
  dlink_empty(dl);
  xfree(dl);
}


