#ifndef __IVEC_H
#define __IVEC_H

struct ivec
{
  /** position variables */
  float x[3];
  /** an orientation matrix */
  float d[9];
};

void
ivec_print(struct ivec);

float
ivec_xmetric(struct ivec,struct ivec);

/* comparison */
int
ivec_cmp(struct ivec,struct ivec);

/** only compare the position */
int
ivec_xcmp(struct ivec,struct ivec);

/** only compare the position and up vector */
int
ivec_ucmp(struct ivec,struct ivec);

/* only compare direction */
int
ivec_dcmp(struct ivec iv,struct ivec _iv);

void
ivec_xcpy(struct ivec*,struct ivec*);

void
ivec_dcpy(struct ivec*,struct ivec*);

/** orient and translate x */
void
ivec_operate(struct ivec,float*x);

struct ivec
ivec_interpolate(struct ivec iv,struct ivec _iv,float t);

struct ivec
ivec_forward(struct ivec iv);

struct ivec
ivec_below(struct ivec iv);

struct ivec
ivec_above(struct ivec iv);

struct ivec
ivec_turn_back(struct ivec iv);

struct ivec
ivec_turn_left(struct ivec iv);

struct ivec
ivec_turn_right(struct ivec iv);

struct ivec
ivec_turn_up(struct ivec iv);

struct ivec
ivec_turn_down(struct ivec iv);

#endif
