#!/usr/bin/env python

import sys
import string
from cursor import *

delta=[
  [cursor_up,cursor_down],
  [cursor_right,cursor_left],
  [cursor_in,cursor_out]]

class Map:
  def __init__(self,bi,bj,bk):
    self.b=(bi,bj,bk)
    self.cursor=[int(bi/2),int(bj/2),int(bk/2)]
    self.cmd=[]
    self.mode=cursor_mode_brick
    self.erase=0
    self.cmode=cursor_cmode_dot
    self.__assert()
    self.dict={} # map coords to content
  def bounded(self,v):
    for i in range(3):
      if v[i]<0 or v[i]>=self.b[i]:
        return 0
    return 1
  def filter(self,f):
    return filter(f,self.dict.keys())
  def idrop(self,j,k):
    pipe=self.filter(lambda v,j=j,k=k:v[1]==j and v[2]==k)
    if pipe:
      return [min(map(lambda v:v[0],pipe))+1,j,k] 
    else: return [0,j,k]
  def jdrop(self,i,k):
    pipe=self.filter(lambda v,i=i,k=k:v[0]==i and v[2]==k)
    if pipe:
      return (i,min(map(lambda v:v[1],pipe))+1,k) 
    else: return [i,0,k]
  def kdrop(self,i,j):
    pipe=self.filter(lambda v,i=i,j=j:v[0]==i and v[1]==j)
    if pipe:
      #return [i,j,min(map(lambda v:v[2],pipe))+1] 
      return map(lambda v,i=i,j=j:[i,j,v[2]+1],pipe) 
    else: return [i,j,0]
  def __assert(self):
    if not self.bounded(self.cursor):
      raise "unbounded ",self.cursor
  def __getitem__(self,i):
    return self.cursor[i]
  def push(self,c):
    self.cmd.append(c);
  def pen_to(self,*v):
    if not self.bounded(v):
      raise "unbounded ",v
    self()
    for i in range(3):
      while self.cursor[i]<v[i]:
        self.cursor[i]+=1
        self.push(delta[i][0])
        self.__assert()
        self()
      while self.cursor[i]>v[i]:
        self.cursor[i]-=1
        self.push(delta[i][1])
        self.__assert()
        self()
  def solid_to(self,*v):
    if not self.bounded(v):
      raise "unbounded ",v
    v=list(v)
    sgn=[1,1,1]
    for i in range(3):
      if v[i]<self[i]:
        sgn[i]=-1
        v[i]-=1
      else:
        v[i]+=1
    #print self.cursor,v,sgn
    ir= range(self[0],v[0],sgn[0])
    jr= range(self[1],v[1],sgn[1])
    kr= range(self[2],v[2],sgn[2])
    for i in ir:
      for j in jr:
        for k in kr:
          #print i,j,k
          self(i,j,k)
  def move_to(self,*v):
    if not self.bounded(v):
      raise "unbounded ",v
    for i in range(3):
      while self.cursor[i]<v[i]:
        self.cursor[i]+=1
        self.push(delta[i][0])
        self.__assert()
      while self.cursor[i]>v[i]:
        self.cursor[i]-=1
        self.push(delta[i][1])
        self.__assert()
    assert self.cursor==list(v)
  def cmd_str(self):
    s=string.join(map(str,self.b))+"\n"
    s=s+string.join(self.cmd,"")
    return s
  def __getattr__(self,name):
    c=eval("cursor_"+name)
    if name[:4]=="mode":
      self.mode=c
    if name[:5]=="cmode":
      self.cmode=c
    if name=="toggle_pen":
      self.erase=not self.erase
    return lambda self=self,c=c:self.push(c)
  def __call__(self,*args):
    if args:
      apply(self.move_to,args)
    self.push(" ")
    self.dict[tuple(self.cursor)]=self.mode
  def write(self,file=sys.stdout):
    #print self.dict.keys()
    file.write(self.cmd_str())

def split(a,n):
  assert n<a
  if n==1:
    return [a]
  _a=[]
  d=[int(len(a)/n)]*n
  #print d
  if n==2:
    if len(a)%2:
      d[0]+=1
  else:
    i,_i=0,len(d)-1
    while reduce(lambda a,b:a+b,d)<len(a):
      assert i<_i
      d[i]+=1
      if reduce(lambda a,b:a+b,d)==len(a):
        break
      d[_i]+=1
      i+=1
      _i-=1
  assert reduce(lambda a,b:a+b,d)==len(a)
  _i=0
  for i in d:
    _a.append(a[_i:_i+i])
    _i+=i
  assert _i==len(a)
  return _a

if __name__=="__main__":
  m=Map(11,11,19)
  m.move_to(0,0,0)
  m.mode_solid()
  m.cmode_ipipe(); m()
  m.mode_brick()
  m.cmode_jpipe(); m()
  m.cmode_kpipe(); m()
  m.mode_hero();
  m.move_to(2,1,0); m()
  m.write()


