#ifndef __MEMORY_H
#define __MEMORY_H

#include "globals.h"

#define MEMORY_CHECK
#ifdef MEMORY_CHECK
void*xmalloc(size_t s);
void*xcalloc(size_t s);
void*xrealloc(void*,size_t s);
void xmark();
int xcheck();
void xfree(void*p);

#else
#include <malloc.h>
#define xmalloc(s)	malloc(s)
#define xcalloc(s)	calloc(1,s)
#define xrealloc(p,s)	realloc((p),(s))
#define xmark()		
#define xcheck()	(1)
#define xfree(p)	free(p)
#endif

#endif
