#include <sys/time.h>
#include <assert.h>
#include <stdlib.h>

#include <SDL/SDL.h>

static struct timeval _tv;

void
mtime_delay(int msec)
{
  SDL_Delay(msec);
}

void
mtime_init()
{
  if (gettimeofday(&_tv,NULL)<0)
    assert(0);
}

int
mtime_get()
{
  struct timeval tv;
  int msec;
  if (gettimeofday(&tv,NULL)<0)
    assert(0);
  msec=(tv.tv_sec-_tv.tv_sec)*1000
       +(tv.tv_usec-_tv.tv_usec)/1000;
  return msec;
}





